/*
    MenuBar.prg - Class(y) menu bar class

    Copyright (c) 1991, 1992 Chris Muller and Anton van Straaten
*/

#include "class(y).ch"

#define OPTION_SPACING  4


CREATE CLASS MenuBar FROM BaseMenu

PROTECTED:
    METHOD  initWin

EXPORT:
    METHOD  addItem
    METHOD  childRow, childCol
END CLASS


// pass parameters up to superclass (will not be necessary in Class(y) 2.0)
CONSTRUCTOR new( aItems ), ( aItems )
RETURN


METHOD PROCEDURE initWin
    ::window := Window():new( 0, 0, 0, 79, ::colorSpec ):show()
RETURN


METHOD PROCEDURE addItem( cLabel, oAction, isActive )
    LOCAL nCol

    // establish screen column for new option
    IF LEN( ::items ) == 0
        nCol := OPTION_SPACING
    ELSE
        nCol := ATail( ::items ):nextCol() + OPTION_SPACING
    ENDIF

    ::addNewItem( 0, nCol, cLabel, oAction, isActive )
RETURN


METHOD childRow
RETURN 1


METHOD childCol
RETURN ::items[::currPos]:col


// eof menubar.prg
