/*
    Window.prg - Class(y) simple window class

    Copyright (c) 1991, 1992 Anton van Straaten

    Created   1 Aug 1991  avs
    Modified 19 Aug 1991  avs
*/

#include "class(y).ch"


CREATE CLASS Window
    VAR     buf
    VAR     colorArr

EXPORT:
    VAR     top, left       READONLY
    VAR     bottom, right   READONLY
    VAR     colorSpec       READONLY

    METHOD  show, hide
    METHOD  clear
    METHOD  frame
    MESSAGE setColor METHOD winSetColor  // since we use SETCOLOR() function in this module
    METHOD  sayAt
END CLASS


CONSTRUCTOR new( nTop, nLeft, nBottom, nRight, cColor )
    ::top    := nTop
    ::left   := nLeft
    ::bottom := nBottom
    ::right  := nRight

    ::setColor( IF( cColor == NIL, SetColor(), cColor ) )
RETURN


METHOD show
    LOCAL buf := SaveScreen( ::top, ::left, ::bottom, ::right )

    SetColor( ::colorSpec )

    IF ::buf == NIL
        ::clear()
    ELSE
        RestScreen( ::top, ::left, ::bottom, ::right, ::buf )
    ENDIF

    ::buf := buf
RETURN self


METHOD PROCEDURE hide
    LOCAL buf := SaveScreen( ::top, ::left, ::bottom, ::right )
    RestScreen( ::top, ::left, ::bottom, ::right, ::buf )
    ::buf := buf
RETURN


METHOD PROCEDURE clear
    @ ::top, ::left CLEAR TO ::bottom, ::right
RETURN


METHOD PROCEDURE frame( type )
    DispBox( ::top, ::left, ::bottom, ::right, type )
RETURN


METHOD winSetColor( cColor )
    IF cColor <> NIL
        ::colorSpec := cColor
        ::colorArr  := ListAsArray( ::colorSpec )
    ENDIF
RETURN ::colorSpec


METHOD PROCEDURE sayAt( nRow, nCol, cTxt, nColor )
    LOCAL cOldColor := setcolor()
    IF nColor <> NIL
        SetColor( ::colorArr[nColor] )
    ENDIF
    @ ::top + nRow, ::left + nCol SAY cTxt
    SetColor( cOldColor )
RETURN
             

// eof window.prg
